<?php

namespace App\Events;

use App\Models\BusinessOrderItem;
use App\Models\GoodsSku;
use Illuminate\Broadcasting\Channel;
use Illuminate\Broadcasting\InteractsWithSockets;
use Illuminate\Broadcasting\PresenceChannel;
use Illuminate\Broadcasting\PrivateChannel;
use Illuminate\Contracts\Broadcasting\ShouldBroadcast;
use Illuminate\Foundation\Events\Dispatchable;
use Illuminate\Queue\SerializesModels;

class BusinessOrdersUpdate
{
    use Dispatchable, InteractsWithSockets, SerializesModels;

    public $num;
    public $businessOrderItem;
    public $goodsSku;

    /**
     * Create a new event instance.
     *
     * @return void
     */
    public function __construct(BusinessOrderItem $item, $num)
    {
        $this->businessOrderItem = $item;
        $this->num = $num;
        $this->updateStock();
    }

    private function updateStock()
    {
        [$goodsCode, $skuCode] = explode('_', $this->businessOrderItem->external_sku_id);
        $this->goodsSku = GoodsSku::query()->where('sku_code', $skuCode)
            ->with(['goods' => function ($query) use ($goodsCode) {
                $query->where('goods_code', $goodsCode);
            }])
            ->first();
        if ($this->goodsSku) {
            $this->goodsSku->stock += $this->num;
            $this->goodsSku->save();
        }
    }

    /**
     * Get the channels the event should broadcast on.
     *
     * @return \Illuminate\Broadcasting\Channel|array
     */
    public function broadcastOn()
    {
        return new PrivateChannel('channel-name');
    }
}
